#ifndef MATHLIB_MATHCONF_H
#define MATHLIB_MATHCONF_H

// detects defects and features of the compiler

// g++
#if __GNUG__
	// unaliased references are supported in g++, use them
#	define MATHLIB_RESTRICT __restrict
#	if __GNUG__ < 3
#		ifndef MATHLIB_NO_USING
#			define MATHLIB_NO_USING	1
#		endif
#		ifndef MATHLIB_LIBSTDCPP2
#			define MATHLIB_LIBSTDCPP2	1
#		endif
#	endif
#endif

// work around libstdc++-v2 defects
#if MATHLIB_LIBSTDCPP2
#	ifndef MATHLIB_NO_LIMITS
#		define MATHLIB_NO_LIMITS	1
#	endif
#	ifndef MATHLIB_NO_OSTREAM
#		define MATHLIB_NO_OSTREAM	1
#	endif
#endif

// unaliased references does not appear to be supported
#ifndef MATHLIB_RESTRICT
#	define MATHLIB_RESTRICT
#endif

#endif
