#ifndef MATHLIB_MATHDEFS_H
#define MATHLIB_MATHDEFS_H

// constants

#include <mathlib/mathconf.h>

#if MATHLIB_NO_LIMITS
#	include <float.h>
#else
#	include <limits>
#endif

namespace mathlib {

const float pi = 3.14159265358979323846;
const float ln_2 = 0.693147180559945309417;
#if MATHLIB_NO_LIMITS
const float epsilon = FLT_EPSILON;
#else
const float epsilon = std::numeric_limits<float>::epsilon();
#endif

struct identity_t {};
struct zero_t {
	operator float() const { return 0.f; }
};

// absence of geometry.
struct nothing {};

// typeless multiplicative identity
const identity_t identity = identity_t();

// typeless zero
const zero_t zero = zero_t();

} // namespace mathlib

#endif
